<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-comms](./foundation-comms.md) &gt; [DataserverParams](./foundation-comms.dataserverparams.md)

## DataserverParams type

Parameters for a DATA\_LOGON messages

**Signature:**

```typescript
export type DataserverParams = {
    DATASOURCE_NAME?: string;
    CRITERIA_MATCH?: string;
    MAX_ROWS?: number;
    VIEW_NUMBER?: number;
    FIELDS?: string;
    MAX_VIEW?: number;
    MOVING_VIEW?: boolean;
    ORDER_BY?: string;
    REVERSE?: boolean;
};
```

## Remarks

- The DATASOURCE\_NAME is required for all DATA\_LOGON messages. - The CRITERIA\_MATCH is optional and can be used to filter the data. - The MAX\_ROWS is optional and can be used to limit the number of rows returned. - The VIEW\_NUMBER is optional and can be used to specify the desired page/view number. - The FIELDS is optional and can be used to specify the desired fields to be returned. - The MAX\_VIEW is optional and can be used to specify the maximum view size. You can have this as 100 and MAX\_ROWS as 50 for example. That way you can fetch 50 rows at a time and have a view size of 100, which is the maximum number of rows that can be displayed in the grid. - The MOVING\_VIEW defines the behaviour of the front-end view when it receives new rows in real time. - The ORDER\_BY is optional and can be used to specify the order of the rows. - The REVERSE is optional and can be used to specify if the order should be reversed. For more information, see the [Dataserver Parameters](https://learn.genesis.global/docs/server/data-server/advanced/?_highlight=moving_view#incoming-data_logon-messages) documentation.

