<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-comms](./foundation-comms.md)

## foundation-comms package

## Classes

|  Class | Description |
|  --- | --- |
|  [AuthError](./foundation-comms.autherror.md) | Represents an error that occurs during authentication. |
|  [CurrentUser](./foundation-comms.currentuser.md) | Represents the current user (i.e. the user that is currently logged in). |
|  [DatasourceDefaults](./foundation-comms.datasourcedefaults.md) | Default values for a DatasourceConfig |
|  [DefaultAuth](./foundation-comms.defaultauth.md) | The default implementation for the Auth interface. |
|  [DefaultConnect](./foundation-comms.defaultconnect.md) | The default implementation for the Connect interface (WS-only). |
|  [DefaultConnectEvents](./foundation-comms.defaultconnectevents.md) | Default ConnectEvents implementation. |
|  [DefaultCredentialManager](./foundation-comms.defaultcredentialmanager.md) | The default implementation for the CredentialManager interface. |
|  [DefaultDatasource](./foundation-comms.defaultdatasource.md) | The default implementation for the Datasource interface. |
|  [DefaultFoundationAnalytics](./foundation-comms.defaultfoundationanalytics.md) | The default implementation for the FoundationAnalytics interface. |
|  [DefaultGenesisResources](./foundation-comms.defaultgenesisresources.md) | Default GenesisResources implementation. |
|  [DefaultHttp](./foundation-comms.defaulthttp.md) | The default implementation of the Http interface. |
|  [DefaultHttpConnect](./foundation-comms.defaulthttpconnect.md) | The default implementation for the Connect interface (HTTP-only). |
|  [DefaultMessageBuilder](./foundation-comms.defaultmessagebuilder.md) | Default MessageBuilder implementation. |
|  [DefaultMetaCache](./foundation-comms.defaultmetacache.md) | The default implementation for the MetaCache interface. |
|  [DefaultNetworkMonitor](./foundation-comms.defaultnetworkmonitor.md) | Default NetworkMonitor implementation. |
|  [DefaultSession](./foundation-comms.defaultsession.md) | The default implementation for the Session interface. |
|  [DefaultSocket](./foundation-comms.defaultsocket.md) | Default Socket implementation. |
|  [DefaultSocketStatus](./foundation-comms.defaultsocketstatus.md) | Default SocketStatus implementation. |
|  [GenesisResourcesMock](./foundation-comms.genesisresourcesmock.md) |  |
|  [SocketMessageHandler](./foundation-comms.socketmessagehandler.md) | The Socket message handler definition. |
|  [SocketObservable](./foundation-comms.socketobservable.md) | Observable that wraps a WebSocketSubject and provides an Observable interface for sending and receiving messages. |
|  [SocketSubject](./foundation-comms.socketsubject.md) | Subject that wraps a WebSocketSubject and provides a Subject interface for sending and receiving messages. |

## Enumerations

|  Enumeration | Description |
|  --- | --- |
|  [AuthType](./foundation-comms.authtype.md) | The available ypes of authentication. |
|  [EventMessageType](./foundation-comms.eventmessagetype.md) | Event Message types |
|  [FieldTypeEnum](./foundation-comms.fieldtypeenum.md) | Available types for a field metadata. |
|  [FoundationAnalyticsEventType](./foundation-comms.foundationanalyticseventtype.md) | Analytics event types |
|  [MessageCode](./foundation-comms.messagecode.md) | General Message codes |
|  [MessageType](./foundation-comms.messagetype.md) | General Message types |
|  [ResourceType](./foundation-comms.resourcetype.md) | Types of Genesis resources. |
|  [SocketReconnectStrategy](./foundation-comms.socketreconnectstrategy.md) | Socket reconnection strategies |

## Functions

|  Function | Description |
|  --- | --- |
|  [criteriaFiltersToFields(filters)](./foundation-comms.criteriafilterstofields.md) | Criteria filters to fields. |
|  [dataServerResultFilter(result, rowId)](./foundation-comms.dataserverresultfilter.md) | Data server result filter. |
|  [getConnect()](./foundation-comms.getconnect.md) | Get Connect from the DI container. |
|  [getDatasource()](./foundation-comms.getdatasource.md) | Get Datasource from the DI container. |
|  [getGenesisResources()](./foundation-comms.getgenesisresources.md) | Gets GenesisResources from the DI container. |
|  [getGenesisResourcesChannel()](./foundation-comms.getgenesisresourceschannel.md) | Gets GenesisResourcesChannel from the DI container. |
|  [getKVStorage()](./foundation-comms.getkvstorage.md) | Gets KVStorage from the DI container. |
|  [getNetworkMonitor()](./foundation-comms.getnetworkmonitor.md) | Gets NetworkMonitor from the DI container. |
|  [getSocket()](./foundation-comms.getsocket.md) | Gets Socket from the DI container. |
|  [getSocketStatus()](./foundation-comms.getsocketstatus.md) | Gets SocketStatus from the DI container. |
|  [normaliseCriteria(criteria, delimiter)](./foundation-comms.normalisecriteria.md) | Normalise criteria. |
|  [until(conditionFunc, timeoutMs)](./foundation-comms.until.md) | Polls a condition function until it returns true or a timeout is reached. |

## Interfaces

|  Interface | Description |
|  --- | --- |
|  [Auth](./foundation-comms.auth.md) | Auth is the main interface for authenticating with a Genesis Server endpoint. |
|  [Connect](./foundation-comms.connect.md) | Represents a connection and its capabilities on a remote server Provides methods to send and receive messages, as well as metadata and schema information. |
|  [ConnectConfig](./foundation-comms.connectconfig.md) | Configuration options for the Connect (WS) instance. |
|  [ConnectEvents](./foundation-comms.connectevents.md) | <code>ConnectEvents</code> provide hooks to respond to specific connect events. |
|  [ConnectEventsEmitter](./foundation-comms.connecteventsemitter.md) | <code>ConnectEventsEmitter</code> provide event emitting hooks to Connect. |
|  [CredentialManager](./foundation-comms.credentialmanager.md) | Represents a system for managing user credentials and authentication tokens. |
|  [CredentialManagerConfig](./foundation-comms.credentialmanagerconfig.md) | The configuration for the CredentialManager |
|  [CredentialManagerCookieConfig](./foundation-comms.credentialmanagercookieconfig.md) | The configuration options for the CredentialManager cookie |
|  [Datasource](./foundation-comms.datasource.md) | Datasource interface. |
|  [DatasourceConfig](./foundation-comms.datasourceconfig.md) | DatasourceConfig DI interface. |
|  [DatasourceMetadata](./foundation-comms.datasourcemetadata.md) | DatasourceMetadata interface. |
|  [DatasourceOptions](./foundation-comms.datasourceoptions.md) | Options that can be passed when initializing a datasource. |
|  [DataUpdate](./foundation-comms.dataupdate.md) | Data Update definition with details of what data to add, drop, and/or modify. |
|  [Dataview](./foundation-comms.dataview.md) | Dataview object |
|  [FoundationAnalytics](./foundation-comms.foundationanalytics.md) | Represents an analytics tracking system. |
|  [GenesisResources](./foundation-comms.genesisresources.md) | GenesisResources DI interface. |
|  [GenesisResourcesChannel](./foundation-comms.genesisresourceschannel.md) | GenesisResourcesChannel DI interface. |
|  [GenesisResourcesConfig](./foundation-comms.genesisresourcesconfig.md) | GenesisResourcesConfig DI interface. |
|  [Http](./foundation-comms.http.md) | An interface representing an HTTP client that can make GET and POST requests and return a promise with the response data. |
|  [HttpRequestInit](./foundation-comms.httprequestinit.md) | The options object used when making an HTTP request. |
|  [JsonSchemaCache](./foundation-comms.jsonschemacache.md) | A JSON schema cache definition |
|  [LogoutResult](./foundation-comms.logoutresult.md) | Represents the result of a user logout operation. |
|  [MessageBuilder](./foundation-comms.messagebuilder.md) | A utility class for building different types of messages. |
|  [MetadataCache](./foundation-comms.metadatacache.md) | A Metadata cache definition |
|  [MonitoredResourceChecksResult](./foundation-comms.monitoredresourcechecksresult.md) | MonitoredResourceChecksResult. |
|  [MonitoredResourceMetadata](./foundation-comms.monitoredresourcemetadata.md) | MonitoredResourceMetadata. |
|  [NetworkMonitor](./foundation-comms.networkmonitor.md) | <code>NetworkMonitor</code> monitors network and resource availability and health. |
|  [NetworkMonitorConfig](./foundation-comms.networkmonitorconfig.md) | NetworkMonitorConfig DI interface. |
|  [SerializedSocketStatus](./foundation-comms.serializedsocketstatus.md) | <code>SerializedSocketStatus</code> provides the serialize state of the web socket. |
|  [Serializer](./foundation-comms.serializer.md) | A Serializer interface for serializing and deserializing objects. |
|  [Session](./foundation-comms.session.md) | Represents a session storage and its capabilities. Provides methods to set and get items from the specified storage. |
|  [Socket](./foundation-comms.socket.md) | Represents a WebSocket used to establish a communication channel between client and a Genesis server. Provides methods for socket connection, sending and receiving WS messages. |
|  [SocketStatus](./foundation-comms.socketstatus.md) | <code>SocketStatus</code> provides the state of the web socket. |
|  [User](./foundation-comms.user.md) | Represents a User object with associated permissions and profiles. |

## Namespaces

|  Namespace | Description |
|  --- | --- |
|  [FoundationAnalyticsEvent](./foundation-comms.foundationanalyticsevent.md) | Namespace for all Analytics event types |
|  [MessageDetails](./foundation-comms.messagedetails.md) | Namespace for all Message detail types |

## Variables

|  Variable | Description |
|  --- | --- |
|  [CommitEventType](./foundation-comms.commiteventtype.md) |  |
|  [credentialSeparator](./foundation-comms.credentialseparator.md) | The default separator used for splitting credential parts. |
|  [DatasourceEventHandler](./foundation-comms.datasourceeventhandler.md) | Datasource event handler mixin for target classes that use or are interested in datasource status changes. |
|  [DatasourceStatusChanged](./foundation-comms.datasourcestatuschanged.md) | DatasourceStatusChanged. |
|  [defaultConnectConfig](./foundation-comms.defaultconnectconfig.md) | The default configuration for connecting to a WS service. |
|  [defaultCredentialManagerConfig](./foundation-comms.defaultcredentialmanagerconfig.md) | The default configuration for the CredentialManager service. |
|  [defaultCredentialRequestOptions](./foundation-comms.defaultcredentialrequestoptions.md) | The default request options for the CredentialManager service. |
|  [defaultDatasourceConfig](./foundation-comms.defaultdatasourceconfig.md) | Default DatasourceConfig DI implementation. |
|  [defaultGenesisResourcesConfig](./foundation-comms.defaultgenesisresourcesconfig.md) | Default GenesisResourcesConfig implementation. |
|  [defaultNetworkMonitorConfig](./foundation-comms.defaultnetworkmonitorconfig.md) | Default NetworkMonitorConfig DI implementation. |
|  [exponentialScheduler](./foundation-comms.exponentialscheduler.md) | Expontential Interval scheduler for reconnect |
|  [extractFieldDefinitions](./foundation-comms.extractfielddefinitions.md) | Extracts the field definitions from the metadata. |
|  [GenesisResourcesChannelId](./foundation-comms.genesisresourceschannelid.md) |  |
|  [isWebSocketExpression](./foundation-comms.iswebsocketexpression.md) | Regular Expression to test valid WebSocket (wss and ws) hosts |
|  [linearScheduler](./foundation-comms.linearscheduler.md) | Linear Interval scheduler for reconnect |
|  [logger](./foundation-comms.logger.md) | Logger for the foundation-comms package |
|  [MAX\_RECONNECT\_ATTEMPTS](./foundation-comms.max_reconnect_attempts.md) | Default number of reconnect attempts |
|  [messageHasErrorCode](./foundation-comms.messagehaserrorcode.md) | Check if the message contains an error code. |
|  [messageOrThrow](./foundation-comms.messageorthrow.md) | Check if the provided message contains an error and throw an Error if it does |
|  [MetadataEventType](./foundation-comms.metadataeventtype.md) |  |
|  [networkLogger](./foundation-comms.networklogger.md) |  |
|  [retryInterval](./foundation-comms.retryinterval.md) | Generate reconnect interval based on scheduler |
|  [StreamCompleteEventType](./foundation-comms.streamcompleteeventtype.md) |  |
|  [StreamErrorEventType](./foundation-comms.streamerroreventtype.md) |  |
|  [StreamEventType](./foundation-comms.streameventtype.md) |  |
|  [SystemHealthChanged](./foundation-comms.systemhealthchanged.md) | SystemHealthChanged. |
|  [toFieldMetadata](./foundation-comms.tofieldmetadata.md) | Converts the field definitions to field metadata. |
|  [TYPES\_MAP](./foundation-comms.types_map.md) | Types map for FieldTypeEnum. |

## Type Aliases

|  Type Alias | Description |
|  --- | --- |
|  [AuthInfo](./foundation-comms.authinfo.md) | Union type of all authentication information types. |
|  [BasicAuthInfo](./foundation-comms.basicauthinfo.md) | Represents basic authentication information. |
|  [BasicCredentialsInput](./foundation-comms.basiccredentialsinput.md) | Represents basic credentials for a user. |
|  [CommitEvent](./foundation-comms.commitevent.md) |  |
|  [CommitEventDetail](./foundation-comms.commiteventdetail.md) |  |
|  [CommitParams](./foundation-comms.commitparams.md) | Parameters for a COMMIT message |
|  [ConnectionStatus](./foundation-comms.connectionstatus.md) | The connection status of the Genesis client. |
|  [CredentialData\_2](./foundation-comms.credentialdata_2.md) | Represents user credentials. |
|  [DataserverParams](./foundation-comms.dataserverparams.md) | Parameters for a DATA\_LOGON messages |
|  [DatasourceStatus](./foundation-comms.datasourcestatus.md) | DatasourceStatus. |
|  [DatasourceStatusChangedEvent](./foundation-comms.datasourcestatuschangedevent.md) | DatasourceStatusChangedEvent. |
|  [FieldMetadata](./foundation-comms.fieldmetadata.md) | Field Metadata definition. |
|  [FilteredDataServerResult](./foundation-comms.filtereddataserverresult.md) | Fitlered result after initial DATASERVER data fetch. |
|  [GenesisConnectEvents](./foundation-comms.genesisconnectevents.md) | Genesis connect events that can be monitored to invoke resource checking. |
|  [GenesisResourcesEvents](./foundation-comms.genesisresourcesevents.md) |  |
|  [GetCredentialOptions](./foundation-comms.getcredentialoptions.md) | Represents options for retrieving credentials. |
|  [IndexDetail](./foundation-comms.indexdetail.md) | Index Detail definition. |
|  [JwtAuthInfo](./foundation-comms.jwtauthinfo.md) | Represents JWT authentication information. |
|  [LoginResult](./foundation-comms.loginresult.md) | Represents the result of a user login operation. |
|  [Message](./foundation-comms.message.md) | Base Message type for all DETAIL variants |
|  [MessageError](./foundation-comms.messageerror.md) | Error definition for a message result |
|  [MetaCache](./foundation-comms.metacache.md) | Union type of MetadataCache and JsonSchemaCache |
|  [Metadata](./foundation-comms.metadata.md) | Metadata definition for a given resource. |
|  [MetadataDetail](./foundation-comms.metadatadetail.md) | Metadata Detail definition. |
|  [MetadataEvent](./foundation-comms.metadataevent.md) |  |
|  [MetadataEventDetail](./foundation-comms.metadataeventdetail.md) |  |
|  [MonitoredResource](./foundation-comms.monitoredresource.md) | MonitoredResource. |
|  [MonitoredResourceChecks](./foundation-comms.monitoredresourcechecks.md) | MonitoredResourceChecks. |
|  [MonitoredResourceDataLogon](./foundation-comms.monitoredresourcedatalogon.md) | MonitoredResourceDataLogon. |
|  [PingMessage](./foundation-comms.pingmessage.md) |  |
|  [PongMessage](./foundation-comms.pongmessage.md) |  |
|  [RawDataServerResult](./foundation-comms.rawdataserverresult.md) | Raw result from a DATASERVER data fetch. |
|  [RefreshAuthInfo](./foundation-comms.refreshauthinfo.md) | Represents refresh token authentication information. |
|  [RefreshCredentialsInput](./foundation-comms.refreshcredentialsinput.md) | Represents refresh credentials for a user. |
|  [ReplyDetail](./foundation-comms.replydetail.md) | Reply Detail definition. |
|  [RequestDetailsParam](./foundation-comms.requestdetailsparam.md) |  |
|  [RequestParams](./foundation-comms.requestparams.md) | Parameters for a REQ\_ messages |
|  [RequestServerResult](./foundation-comms.requestserverresult.md) | Raw result from a REQUEST\_SERVER data fetch. |
|  [ResourceHealth](./foundation-comms.resourcehealth.md) | ResourceHealth. |
|  [ResourceItem](./foundation-comms.resourceitem.md) |  |
|  [ResourcesMessage](./foundation-comms.resourcesmessage.md) |  |
|  [RowData](./foundation-comms.rowdata.md) | Row Data definition. |
|  [SchemaResponse](./foundation-comms.schemaresponse.md) | Schema Response definition. |
|  [ServerRow](./foundation-comms.serverrow.md) | Server Row definition. |
|  [SocketConnectOptions](./foundation-comms.socketconnectoptions.md) | The Socket connection options definition. |
|  [SocketReconnectOptions](./foundation-comms.socketreconnectoptions.md) | Socket reconnection options |
|  [SocketReconnectScheduler](./foundation-comms.socketreconnectscheduler.md) | Socket reconnection scheduler |
|  [SsoAuthInfo](./foundation-comms.ssoauthinfo.md) | Represents SSO authentication information. |
|  [SSOCredentialsInput](./foundation-comms.ssocredentialsinput.md) | Represents SSO credentials for a user. |
|  [StorageType](./foundation-comms.storagetype.md) | The available browser storage types. |
|  [StreamCompleteEvent](./foundation-comms.streamcompleteevent.md) |  |
|  [StreamCompleteEventDetail](./foundation-comms.streamcompleteeventdetail.md) |  |
|  [StreamErrorEvent](./foundation-comms.streamerrorevent.md) |  |
|  [StreamErrorEventDetail](./foundation-comms.streamerroreventdetail.md) |  |
|  [StreamEvent](./foundation-comms.streamevent.md) |  |
|  [StreamEventDetail](./foundation-comms.streameventdetail.md) |  |
|  [StreamEventFunctions](./foundation-comms.streameventfunctions.md) |  |
|  [SystemHealthChangedEvent](./foundation-comms.systemhealthchangedevent.md) | SystemHealthChangedEvent. |
|  [SystemHealthStatus](./foundation-comms.systemhealthstatus.md) | SystemHealthStatus. |

